/*	MIRS9805
 * 	task03.c	:ԊOZT^XN
 *	Version 0.04	(99/07/20)
 *	By @	쐬 '99/06/15  
 * 
 * 	History
 *	0.04 99/07/20	Beta version
 *   	0.03 99/07/07	XC
 *   	0.02 99/06/25	ύX
 * 	0.01 99/06/15	First version
 */

#include "mirx68k.h"		/* MIRX68K header file */
#include "hard.h"		/* Hardware function library header file */
#include "defs.h"		/* MIRS9805 defination header file */

static int count;			/*  */
static int data;			/* IRS data */

void inzt03(){
	irs_init(3);			/* initialize irs	*/
	sys0(3,0x1010);			/* Timer task only */
	sys8(3,0,0);			/* IRS data */
	sys8(3,1,0);			/*  */
	sys8(3,2,0);			/* Not used */
	sys8(3,3,0);			/* Not used */
	sys8(3,4,0);			/* Not used */
	sys8(3,5,0);			/* Not used */
	sys8(3,6,0);			/* Not used */
	sys8(3,7,0);			/* Not used */
	sys8(3,8,0);			/* Not used */
	sys8(3,9,0);			/* Not used */
	sys2(3,TIMER_IRS,0,0);		/* register timer task */
	sys4(3);			/* Stop timer */
	sys3(3,0);			/* Start timer */
	count=0;			/* initialize variable */
	data=0;				/* initialize variable */
	irs_disable_int();		/* disable interrupt	*/
}

void nrmt03(cm,scm){
}

void timt03(cm,scm){

/*	data=irs_data()&(0xff-boot_irs); */
	data=irs_data();		/* read IRS data */
	count++;			/* count-up */

	sys8(3,0,data);			/* write data into BB */
	sys8(3,1,count);		/* write count into BB */
}

interrupt void intt03(){
}
