/*	MIRS9805
 *	Task12	: Subsytem test
 *	Version	0.01	(99/09/14)
 *	by Kento 99/09/14
 *
 *	History
 *	0.01 99/07/13	First version
 */

#include "mirx68k.h"		/* MIRX68K header file */
#include "hard.h"		/* Hardware function library header file */
#include "defs.h"		/* MIRS9805 defination header file */

#define PDN 14

static int pu,pu_old;
static int uss_num;
static int uss_count;
static int flags;
static int cnt;
static int RE[3];		/* RÊ߂LED\p̔z		*/
static int XY[3];		/* XYŴ߂LED\p̔z	*/
static int n=0;
static int a=0;
static int of=-10;
static int pdd[PDN]={0,15,30,45,60,75,100,0,-15,-30,-45,-60,-75,-100};
static int pddd[2]={0,0};
static float limit[2]={1000,1000};
static int pd;
static int dd;
static int flag=0;
static int map[4][2]={{0,0},{60,0},{60,60},{0,60}};
static float stat[3]={0,-30,PI};
static px=0,ff=0,pp=0,shuflag=0;


void inzt12(){
	int i;
	sys0(12,0x1110);
	sys8(12,0,0);			/* init */
	sys8(12,1,0);			/* init */
	sys8(12,2,0);			/* init */
	sys8(12,3,0);			/* init */
	sys8(12,4,0);			/* init */
	sys8(12,5,0);			/* init */
	sys8(12,6,0);			/* init */
	sys8(12,7,0);			/* init */
	sys8(12,8,0);			/* init */
	sys8(12,9,0);			/* init */
	sys2(12,10,0,0);		/* register timer task */
	sys4(12);			/* stop */
	pu=pu_old=1;
	uss_num=0;
	uss_count=0;
	for(n=0; n<3; n++)
		RE[n]=0;
	for(n=0; n<3; n++)
		XY[n]=0;
	SET_VAL(0,7,TRUE);		/* enable button-interrupt */
	sys3(12,1);			/* start */
	flags=0;
	cnt=0;
	sys1(2,PY_JIK,2,(int)limit);
	sys1(2,PY_JIK,1,(int)stat);

}

void nrmt12(int cm, int scm){
	
}

void timt12(int cm, int scm){
	int i,k,dis,b;
	cnt++;
	flags=sys9(0,8);		/* [^XCb`ǂݍ */
	if(flags==0){			/* gЂƂeXg */
		if(of!=flags){
			LED_SET(0);		/* _Ȃ */
		}
		pu_old=pu;
		pu=sys9(0,9);
		if(pu!=pu_old){
			sys1(1,PY_USS,2,0);
			uss_num++;
			if(uss_num>3)
				uss_num=0;
			uss_count=sys9(1,(uss_num<<1)+1);
			sys1(1,PY_USS,1,uss_num);
		}
		k=sys9(1,(uss_num<<1)+1);
		if(uss_count!=k){
			uss_count=k;
			sys1(1,PY_USS,1,uss_num);
		}
		dis=sys9(1,uss_num<<1)+uss_num*1000;
		DISP_SET(0,dis);
	} else if(flags==1){			/* g؂ɃeXg */
		if(of!=flags){
			LED_SET(0);		/* _Ȃ */
		}
		if(sys9(1,8)==0){
			sys1(1,PY_USS,1,3);
			sys1(1,PY_USS,1,2);
			sys1(1,PY_USS,1,1);
			sys1(1,PY_USS,1,3);
			sys1(1,PY_USS,1,2);
			sys1(1,PY_USS,1,1);
		}
		pu_old=pu;
		pu=sys9(0,9);
		if(pu!=pu_old){
			uss_num++;
			if(uss_num>3)
				uss_num=0;
		}
		dis=sys9(1,uss_num<<1)+uss_num*1000;
		DISP_SET(0,dis);
	} else if(flags==2){			/* ԊO */
		int irs;
		if(of!=flags){
			LED_SET(1);			/* ԓ_ */
		}
		irs=sys9(3,0);
		DISP_SET(0,irs);
	} else if(flags==3){		/* R.E. test by freddie */
		if(of!=flags){
			LED_SET(0x10);			/* Γ_	*/
		}
		RE[0]=sys9(2,3);		/* Right RE value	*/
		RE[1]=sys9(2,4);		/* Left RE value	*/
		RE[2]=sys9(2,6);		/* MIRS direction	*/
		
		pu_old=pu;
		pu=sys9(0,9);
		if(pu!=pu_old){
			n++;
			if(n>2)
				n=0;
		}
		DISP_SET(0,RE[n]);
	} else if (flags==4){		/* R.E. test by freddie */
		if(of!=flags){
			LED_SET(0x10);			/* Γ_	*/
		}
		XY[0]=sys9(2,0);		/* X-W	*/
		XY[1]=sys9(2,1);		/* Y-W	*/
		XY[2]=sys9(2,2);		/*  pp	*/

		pu_old=pu;
		pu=sys9(0,9);
		if(pu!=pu_old){
			n++;
			if(n>2)
				n=0;
		}
		DISP_SET(0,XY[n]);
	} else if(flags==5){
		if(of!=flags){
			dis=LED_GET();			/* _ */
			dis&=0x0f;			/* ԐF	*/
			dis|=0x03;			/* ł	*/
			LED_SET(dis);			/* ԓ_	*/
		}
		DISP_SET(0,sys9(2,5));		/* touch sensor data	*/
	} else if(flags==6){			/* PWM	left*/
		if(of!=flags){
			dis=LED_GET();			/* _ */
			dis&=0xf0;			/* ΐF	*/	
			dis|=0x30;			/* ł	*/
			LED_SET(dis);			/* Γ_	*/
		}
		pu_old=pu;
		pu=sys9(0,9);
		if(pu!=pu_old){
			pd++;
			if(pd>=PDN)
				pd=0;
		}
		pddd[0]=pdd[pd];
		pddd[1]=0;
		sys1(4,PY_PWM,6,(unsigned int)pddd);
		DISP_SET(0,pdd[pd]);
	} else if(flags==7){			/* PWM	right*/
		if(of!=flags){
			dis=LED_GET();			/* _ */
			dis&=0xf0;			/* ΐF	*/	
			dis|=0x30;			/* ł	*/
			LED_SET(dis);			/* Γ_	*/
		}
		pu_old=pu;
		pu=sys9(0,9);
		if(pu!=pu_old){
			pd++;
			if(pd>=PDN)
				pd=0;
		}
		pddd[0]=0;
		pddd[1]=pdd[pd];
		sys1(4,PY_PWM,6,(unsigned int)pddd);
		DISP_SET(0,pdd[pd]);
	} else if(flags==8){			/* PWM */
		if(of!=flags){
			dis=LED_GET();			/* _ */
			dis&=0xf0;			/* ΐF	*/	
			dis|=0x30;			/* ł	*/
			LED_SET(dis);			/* Γ_	*/
		}
		if(flag==0){
			flag=1;
		}
		pu_old=pu;
		pu=sys9(0,9);
		if(pu!=pu_old){
			pd++;
			if(pd>=PDN)
				pd=0;
		}
		pddd[0]=pdd[pd];
		pddd[1]=pdd[pd];
		sys1(4,PY_PWM,6,(unsigned int)pddd);
		DISP_SET(0,pdd[pd]);
	} else if(flags==9){			/* PWM */
		if(of!=flags){
			dis=LED_GET();			/* _ */
			dis&=0xf0;			/* ΐF	*/	
			dis|=0x30;			/* ł	*/
			LED_SET(dis);			/* Γ_	*/
		}
		pu_old=pu;
		pu=sys9(0,9);
		if(pu!=pu_old){
			pd++;
			if(pd>=PDN)
				pd=0;
		}
		pddd[0]=pdd[pd];
		pddd[1]=-pdd[pd];
		sys1(4,PY_PWM,6,(unsigned int)pddd);
		DISP_SET(0,pdd[pd]);
	} else if(flags==10){			/* R.E. */
		pu_old=pu;
		pu=sys9(0,9);
		if(pu!=pu_old){
			dd++;
			if(dd>=6)
				dd=0;
		}
		DISP_SET(0,sys9(2,dd));
	} else if(flags==11){
		if(of!=flags){
			dis=0x73;			/* ݓ_łł	*/
			LED_SET(dis);			/* ԗΓ_	*/
		}
		if(shuflag==0){
			pu_old=pu;
			pu=sys9(0,9);
			if(pu!=pu_old){
				shuflag=1;
			}
		} else {
			b=ABS(sys9(2,px));
			DISP_SET(0,b+pp*1000);
			pu_old=pu;
			pu=sys9(0,9);
			if(pu!=pu_old){
				px=(px==0)?1:0;
			}
			if(ff==0){
				sys1(6,PY_SHU,7,(int)(&map[pp]));/* CJn */
				ff=1;
			} else{
				if(sys9(6,4)==TRUE){
					pp++;
					if(pp>3)
						pp=0;
					ff=0;
				}
			}
			if((sys9(2,5))!=0){
				SET_VAL(6,0,FALSE);
				sys1(4,PY_PWM,5,0);
				shuflag=0;
				ff=0;
			}
		}
	}
	of=flags;
}

interrupt void intt12(){
}

/* end of file 'task12.c' (-.-) */
