/*	MIRS9805
 * 	task04.c	:PWM^XN
 *	Version 0.05	(99/07/20)
 *	By @	쐬 '99/06/25  
 * 
 * 	History
 * 	0.06 99/09/13	MIRS9805@ɑΉ
 * 	0.05 99/07/20	Beta version
 * 	0.04 99/07/17	ȈՃtB[hobNȂ(by Kento)
 * 	0.03 99/07/15	f[eBݒl܂ŏXɕω(timer task)
 * 	0.02 99/06/30	@\ǉ
 * 	0.01 99/06/25	First version
 */

#include "mirx68k.h"		/* MIRX68K header file */
#include "hard.h"		/* Hardware function library header file */
#include "defs.h"		/* MIRS9805 defines header file */

#define MAXV	0.5f		/* ōXs[h [m/s]	*/
#define MAXP	(MAXV/(COEF*2.0f))	/* ōXs[hł̃pX	*/
#define TO_PWM(x) ((100.0f/MAXP)*x)	/* 1/MAXP R.E -> PWM	*/

#define L 1
#define R 0

#define PWM_LIMIT 100

static	int	to_pwm[2];			/* ڕWf[eB*/
static	int	to_pwm_old[2];			/* ڕWf[eBߋ*/
static	float	pwm[2];				/* f[fB		*/
static	float	level[2];			/* ␳p̒l	*/

void inzt04(){					/* CjVCY */
	int i;
	sys0(4,0x1110);				/* ^XN̏ݒ */
	sys8(4,0,0);				/* Ẽf[eB̏ */
	sys8(4,1,0);				/* ̃f[eB̏ */
	sys8(4,2,0);				/* ۂ̉Ef[eB */
	sys8(4,3,0);				/* ۂ̍f[eB */
	sys8(4,4,0);				/* R.EPWMɊZ(E) */
	sys8(4,5,0);				/* R.EPWMɊZ() */
	sys8(4,6,0);				/* Not used */
	sys8(4,7,0);				/* Not used */
	sys8(4,8,0);				/* Not used */
	sys8(4,9,0);				/* Not used */
	sys2(4,TIMER_PWM,0,0);			/* Resister Timer Task	*/
	sys4(4);
	pwm_init();				/* PWM̏ */
	for(i=0;i<2;i++){
		pwm[i]=0;
		to_pwm[i]=0;
		to_pwm_old[i]=0;
	}
	level[R]=0.22;				/* tB[hobN̋ */
	level[L]=0.22;
	pwm_data(0,0);				/* [^[~ */
	sys3(4,1);
}

void nrmt04(int cm,int scm){			/* m[}^XN */
	int i;
	for(i=0;i<2;i++){
		to_pwm_old[i]=to_pwm[i];
	}
	if(cm==1){				/* R}hI */
		pwm_data(to_pwm[L],to_pwm[R]);	/* pwmf[^M */
	} else if(cm==2){			/* R}hI */
		to_pwm[R]=scm;			/* Ẽf[eBݒ */
	} else if(cm==3){			/* R}hI */
		to_pwm[L]=scm;			/* ̃f[eBݒ */
	} else if(cm==4){			/* R}hI */
		to_pwm[R]=to_pwm[L]=scm;	/* Ẽf[eBݒ */
	} else if(cm==5){			/* R}hI */
		to_pwm[R]=scm;			/* Ẽf[eBݒ */
		to_pwm[L]=-scm;			/* ̃f[eBݒ */
	} else if(cm==6){
		to_pwm[R]=*((int *)(scm));	/* Ẽf[eBݒ */
		to_pwm[L]=*((int *)(scm)+1);	/* ̃f[eBݒ */
	
	}
	for(i=0;i<2;i++){
		if(to_pwm[i]>100){
			to_pwm[i]=100;
		} else if(to_pwm[i]<-100){
			to_pwm[i]=-100;
		}
	}
	sys8(4,0,to_pwm[R]);		/* Ẽf[eB䏑 */
	sys8(4,1,to_pwm[L]);		/* ̃f[eB䏑 */

}

interrupt void intt04(){			/* 荞݃^XN */

}

void timt04(int cm,int scm){			/* ^C}[^XN */
	int enc[2];
	float pwmd[2];
	int p[2];
	int i;

	enc[R]=sys9(2,3);
	enc[L]=sys9(2,4);
	enc[L]=-enc[L];
	
	for(i=0;i<2;i++){		/* R.ẼtB[hobN */
		pwmd[i]=level[i]*((float)to_pwm[i]-(float)TO_PWM(enc[i]));
		pwm[i]+=pwmd[i];
		p[i]=(int)pwm[i];
	}
	for(i=0;i<2;i++){
		if(p[i]>PWM_LIMIT){
			pwm[i]=PWM_LIMIT;
			p[i]=(int)pwm[i];
		}
		if(p[i]<-PWM_LIMIT){
			pwm[i]=-PWM_LIMIT;
			p[i]=(int)pwm[i];
		}
	}
	pwm_data(-p[L],p[R]);			/* M */
	sys8(4,2,p[R]);
	sys8(4,3,p[L]);
	sys8(4,4,(int)TO_PWM(enc[R]));
	sys8(4,5,(int)TO_PWM(enc[L]));


	
}
